# populateSelectControl.py

# import Throught-The-Web(TTW) API
from kss.core.ttwapi import startKSSCommands, getKSSCommandSet, renderKSSCommands
#other imports

#get widget and request objects
request = context.REQUEST
field_name = request['jidTreeVocabularyWidgetFieldName']
widget = context.getField(field_name).widget
select_number = int(request['selectionControlNumber'])

#start a view for commands
startKSSCommands(context, request)
core = getKSSCommandSet('core')

if int(widget.level_numbers) == select_number:
    if field_name+'_selection'+str(select_number) in request.keys():
        widget.setLastLevelValues(values=request[field_name+'_selection'+str(select_number)], field_name=field_name, request=request)
    else:
        widget.setLastLevelValues(values=[], field_name=field_name, request=request)

    #update selected values in hidden input
    nm = widget.getWidgetSelValsVariableName(field_name)
    selected_values_html = '''
                    <input type=\"hidden\"
                         value=\"'''+request.get(nm, '')+'''\"
                         name=\"'''+nm+'''\"
                         id=\"'''+nm+'''\" />'''
    selector_hidden_vals = core.getHtmlIdSelector(nm)
    core.replaceHTML(selector_hidden_vals, selected_values_html)

    return renderKSSCommands()

#generate search form HTML
htmlCode = widget.fillSelection(context,request)

#add a command
selector = core.getHtmlIdSelector(field_name+'_divSelection'+str(select_number+1))
core.replaceHTML(selector, htmlCode)

#update selected values in hidden input
nm = widget.getWidgetSelValsVariableName(field_name)
selected_values_html = '''
                <input type=\"hidden\"
                     value=\"'''+request.get(nm, '')+'''\"
                     name=\"'''+nm+'''\"
                     id=\"'''+nm+'''\" />'''
selector_hidden_vals = core.getHtmlIdSelector(nm)
core.replaceHTML(selector_hidden_vals, selected_values_html)

#for all appropriate selection controls clear values list
if select_number + 2 <= int(widget.level_numbers):
    for number in range(select_number+2 , int(widget.level_numbers)+1):
        context.REQUEST.set('clear_control_level', number)
        context.clearSelectControl(control_number = number, core=core)

#render the commands
return renderKSSCommands()
